#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"


#define	Number	pow(10,3)	//the numebr of data
#define alpha_e	2.5
dsfmt_t dsfmt1;				//random number

int double_comp(const void *_a, const void *_b) {	//for qsort : ascending
	double a = *(double *)_a;
	double b = *(double *)_b;
	
	if (a > b)		return 1;
	else if (a < b)	return -1;
	else			return 0;
}


int main( int argc , char *argv[] ){
	double xmin = atof(argv[1]);
	int i, j , seed ;
	double x;
	double C = exp(-alpha_e);
	double *rand , *CDF;
	double alpha , sum , tmp,D;
	double min_alpha, min_D;
	int min_i ;
	rand = (double *)calloc( Number , sizeof(double) );
	CDF = (double *)calloc( Number , sizeof(double) );
	char *fn;
	fn = (char *)calloc( 100 , sizeof(char) );
	sprintf( fn , "min_%s.dat", argv[1] );
	FILE *fp;
	if( (fp = fopen( fn , "w" )) ==NULL ){
		printf("File error\n");
	}
	
	
	for(seed=0; seed<100; seed++ ){
	//Seed of random number
	dsfmt_init_gen_rand(&dsfmt1,seed );

	//generate the random number
	for( i= 0; i< Number ; i++){
		x = dsfmt_genrand_close_open(&dsfmt1) ;
		if( x <= C){
			rand[i] = xmin * pow( x/C , -1.0/alpha_e );
		}
		else{
			rand[i] = xmin * ( 1.0 -  log(x/C)/alpha_e );
		}
	}
	//
	qsort( rand , Number , sizeof(double) , double_comp );

	// move the xmin
	for( i=0 ; i<Number-1 ; i++ ){
		
		sum = 0.0;
		for( j = i ; j < Number ; j++ ){
			CDF[j] = (double)(Number-j)/(Number-i);
			sum += log(rand[j]/rand[i]);
		}
		alpha = (double)(Number-i)/sum;
		
		//statistics D
		for( j=i ; j<Number ; j++ ){
			tmp = fabs( CDF[j] -  pow( rand[j]/rand[i] ,-alpha ) );
			D = ( j==i || D < tmp )?  tmp : D ;
		}
	
		//Minimum
		tmp = sqrt(Number-i) * D;
		if( i==0 || min_D > tmp ){
			min_D = tmp;
			min_i = i;
			min_alpha = alpha;
		}
	}
	fprintf( fp , "%f	%f\n", rand[min_i] , min_alpha);
	}
	
	fclose(fp);
	free(fn);
	free(rand);
	free(CDF);
	
	return 0;
}

