#!/bin/bash

##Trial=100

echo  -n "" > min.dat
gcc -o 	problem3_6_5.exe 	problem3_6_5.c 	dSFMT.c


for xmin in 2 4 8 16 32 64
do

./problem3_6_5.exe ${xmin}

sort -k1g min_${xmin}.dat | \
awk -v xmin="${xmin}" '
{
	x[NR] = $1;
}
END{
	mid = (x[50] + x[51])/2;
	q1  = x[25];
	q3  = x[75];
	print( xmin ,mid , q1 , q3 );
}
'  >> min.dat



echo "${xmin}"

done



gnuplot <<EOF
set terminal postscript eps enhanced color
set output "min.eps"
set size 0.6,0.6
set log xy 2
set xlabel "x_{min}"
set ylabel "Estimated Value"
set xrange [1.8:70]
set format x "2^{%L}"
set format y "2^{%L}"
set key left top
plot 	"min.dat" u 1:2:3:4 w yerrorbars title "quantile"  pt 7 ,\
		1.6*x w l title "1.6x_{min}",\
		1.1*x w l title "1.1x_{min}",\\
		2.8*x w l title "2.8x_{min}"
EOF